#!/usr/bin/perl -w
# czyta zakresy struktur II-rz z pliku "zakresy.csv"
# generuje restrains odpowiednie do zdef. str.
# na wszystkie pozostale naklada trans-OME i L-chiralnosci
#
# for CASP11 refinement, PQ LTD 28042k14.0959
#
# alfa HELISA:
$Hphi=-60; $Hphidev=7; # od PHI-dev do PHI+dev
$Hpsi=-45; $Hpsidev=7; # od PSI-dev do PSI+dev
#
# beta KARTKA:
$Sphi=-129; $Sphidev=20; # od PHI-dev do PHI+dev; paral: -119, antyparal: -139
$Spsi=124;  $Spsidev=20; # od PSI-dev do PSI+dev; paral: 113, antyparal: 135
#
# ============ DO NOT TOUCH BELOW THIS LINE ============
#
if (defined($ARGV[0]) and -e $ARGV[0]) {
  if (-e 'zakresy.csv'){
    #
    open (F,"<zakresy.csv");
    @zakresy=<F>; close (F);
    for ($i=0;$i<=$#zakresy;$i++){
      next if ($zakresy[$i] =~ /^#/ or $zakresy[$i] !~ /;/);
      chomp ($zakresy[$i]);
      @zak=split ';',$zakresy[$i];
      for ($j=$zak[0];$j<=$zak[1];$j++){
        $zak[2] =~ tr/[a-z]/[A-Z]/;
        $str[$j]=$zak[2];
      }
    }
    open (F,"<$ARGV[0]");
    @pdb=<F>; close (F);
    open (O,">$ARGV[0]\.rst");
    for ($i=0;$i<=$#pdb;$i++){
      next if ($pdb[$i] !~ /^ATOM/);
      @lin=split ' ',$pdb[$i];
      next unless ($lin[2] eq 'C');
      if (defined ($str[$lin[4]])){
        $Hphiod=$Hphi-$Hphidev; $Hphido=$Hphi+$Hphidev;
        $Hpsiod=$Hpsi-$Hpsidev; $Hpsido=$Hpsi+$Hpsidev;
        $Sphiod=$Sphi-$Sphidev; $Sphido=$Sphi+$Sphidev;
        $Spsiod=$Spsi-$Spsidev; $Spsido=$Spsi+$Spsidev;
        print O "$lin[4] $lin[3] PHI $Hphiod $Hphido\n$lin[4] $lin[3] PSI $Hpsiod $Hpsido\n" if ($str[$lin[4]] eq 'H');
        print O "$lin[4] $lin[3] PHI $Sphiod $Sphido\n$lin[4] $lin[3] PSI $Spsiod $Spsido\n" if ($str[$lin[4]] eq 'S');
      } # all C kabonyl.
    }
    close (O);
    $sc='/users2/lukasz/CASP_RST';
    `$sc/makeANG_RST -lib $sc/tordef.lib -pdb $ARGV[0] -con $ARGV[0]\.rst > RST1.dat; rm -f $ARGV[0]\.rst`;
    `$sc/makeCHIR_RST $ARGV[0] RST2.dat; cat RST?.dat > RST.dat; rm -f RST?.dat`;
#    $reszt=$lin[4];
#    print "Reszt: $reszt\n";
    #
  } else {
    print "Nie ma pliku z zakresami struktur II-rz. \"zakresy.csv\"\n";
  }
} else { # defined
  print "Podaj nazwe pliku PDB.\n";
} # defined



